﻿using System;
using System.ComponentModel;
using MemoryLeak.Annotations;

namespace MemoryLeak {
  public class ViewModel : INotifyPropertyChanged {

    private int _number;
    public int[,,] _bigArray = new int[10, 1024, 1024];
    public event PropertyChangedEventHandler PropertyChanged;

    public ViewModel() {
      _number = new Random().Next();
    }

    [NotifyPropertyChangedInvocator]
    protected virtual void OnPropertyChanged(string propertyName) {
      PropertyChangedEventHandler handler = PropertyChanged;
      if (handler != null)
        handler(this, new PropertyChangedEventArgs(propertyName));
    }

    public int Number {
      get { return _number; }
      set {
        if (value == _number) return;
        _number = value;
        OnPropertyChanged("Number");
      }
    }

  }

}